//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "u_conbine.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
Tfrm_conbine *frm_conbine;
//---------------------------------------------------------------------------
__fastcall Tfrm_conbine::Tfrm_conbine(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall Tfrm_conbine::img_laterMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
  pBitmap->Assign(img_later->Picture);
  byte r,g,b;
  COLORREF color;
  color=pBitmap->Canvas->Pixels[X][Y];

  r=GetRValue(color);
  g=GetGValue(color);
  b=GetBValue(color);

  lbl_R->Caption=r;
  lbl_G->Caption=g;
  lbl_B->Caption=b;
}
//---------------------------------------------------------------------------
void __fastcall Tfrm_conbine::img_laterMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  edt_R->Text=lbl_R->Caption;
  edt_G->Text=lbl_G->Caption;
  edt_B->Text=lbl_B->Caption;
}
//---------------------------------------------------------------------------
void __fastcall Tfrm_conbine::btn_load_1Click(TObject *Sender)
{
  if(OpenPictureDialog1->Execute())
    img_before->Picture->LoadFromFile(OpenPictureDialog1->FileName);        
}
//---------------------------------------------------------------------------
void __fastcall Tfrm_conbine::btn_load_2Click(TObject *Sender)
{
  if(OpenPictureDialog2->Execute())
    img_later->Picture->LoadFromFile(OpenPictureDialog2->FileName);        
}
//---------------------------------------------------------------------------
void __fastcall Tfrm_conbine::btn_conbineClick(TObject *Sender)
{
  byte i,j,k,r;
  i=StrToInt(edt_R->Text);
  j=StrToInt(edt_G->Text);
  k=StrToInt(edt_B->Text);
  r=StrToInt(edt_margin->Text);
	
  int x,y;
  int pic_h,pic_w;
  pic_w=img_before->Width;
  pic_h=img_before->Height;

  Byte *ptr;
  Byte *ptr_1;
  Byte *ptr_2;

  pBitmap->Assign(img_before->Picture);           //l
  pBitmap_1->Assign(img_later->Picture);          //X
  pBitmap_2->Assign(img_later->Picture);         //X

  pBitmap->PixelFormat=pf24bit;
  pBitmap_1->PixelFormat=pf24bit;
  pBitmap_2->PixelFormat=pf24bit;

  for(y=0;y<pic_h;y++)
  {
    //˹Ϥ
    ptr=(Byte *)pBitmap->ScanLine[y];
    ptr_1=(Byte *)pBitmap_1->ScanLine[y];
    ptr_2=(Byte *)pBitmap_2->ScanLine[y];
    //NRBGBB ӧOX
    for(x=0; x<pic_w*3;x+=3)
    {
      //P_dAå[HN
      if( ((ptr_1[x+2]<=i+r)&&(ptr_1[x+2]>=i-r))&&
          ((ptr_1[x+1]<=j+r)&&(ptr_1[x+1]>=j-r))&&
	  ((ptr_1[x]<=k+r)&&(ptr_1[x]>=k-r)) )
      {
        ptr_2[x]=ptr[x];
        ptr_2[x+1]=ptr[x+1];
	ptr_2[x+2]=ptr[x+2];
      }
    }
  }
  img_later->Canvas->Draw(0,0,pBitmap_2);         //ܦXϤ        
}
//---------------------------------------------------------------------------
void __fastcall Tfrm_conbine::Button1Click(TObject *Sender)
{
  if(SavePictureDialog1->Execute())
    img_later->Picture->SaveToFile(SavePictureDialog1->FileName);        
}
//---------------------------------------------------------------------------
void __fastcall Tfrm_conbine::Button4Click(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall Tfrm_conbine::FormDestroy(TObject *Sender)
{
  delete pBitmap,pBitmap_1,pBitmap_2;        
}
//---------------------------------------------------------------------------
